/*+M*************************************************************************
 * Promise FastTrak device driver for Linux.
 *
 * Copyright (c) 2002  Promise Technology, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * --------------------------------------------------------------------------  
 * Copyright (c) 1999-2002 Promise Technology, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * Where this Software is combined with software released under the terms of 
 * the GNU Public License ("GPL") and the terms of the GPL would require the 
 * combined work to also be released under the terms of the GPL, the terms
 * and conditions of this License will apply in addition to those of the
 * GPL with the exception of any terms or conditions of this License that
 * conflict with, or are expressly prohibited by, the GPL.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *   		
 *-M*************************************************************************/

/***************************************************************************
 *
 * ata-3.h - contains ata-3 interface definition and mappings
 *
 ***************************************************************************/

/*
 * ATA Access limitation
 */

#define MAX_DISK_ACCESS_SIZE            0x80    /* in sectors */

#define IDE_COMMAND_SMART				0xb0

/*
 * ATA access opcode
 */

#define ataREAD                         0x20
#define ataREAD_VERIFY                  0x40
#define ataSEEK                         0x70
#define ataWRITE                        0x30
#define ataWRITE_VERIFY                 0x3C
#define ataREAD_LONG					0x22
#define ataWRITE_LONG					0x32
#define ataIDENTIFY_DEVICE              0xEC
#define ataSET_LED						0xf0
#define MODEL_NAME_OFFSET             54


/*
 * bStatus in DTASK
 */
#define tsPRD_TOO_SMALL                 0x00
#define tsDMA_ENGINE_STUCK              0x01
#define tsXFER_ERROR                    0x02
#define tsNO_ERROR                      0x04
#define tsPRD_TOO_LARGE                 0x05
#define tsTIMED_OUT                     0x80    /* bit0~2 from chip status */
#define tsFORCE_RETRY_TASK              0xFD
#define tsFORCE_RETRY_REQ               0xFE
#define tsSELECTION_TIMEOUT             0xFF
#define tsBUS_MASTER_STATUS_MASK        0x07


/*
 * DTASK.ata_reg.cmd.bStstaus ATA Status Register Values
 */
#define ataADDITIONAL_ERROR             0x01    /* bit 7 == 0, ERR */
#define ataCORRECTED_DATA               0x04    /* bit 7 == 0, CORR */
#define ataDATA_REQUEST                 0x08    /* bit 7 == 0 */
#define ataSEEK_COMPLETE                0x10    /* BIT4 */
#define ataDEVICE_WRITE_FAULT           0x20    /* bit 7 == 0 */
#define ataDRIVE_READY                  0x40    /* bit 7,5,3,2,0 == 0, DRDY */
#define ataDRIVE_BUSY                   0x80    /* BSY */
#define ataDRIVE_READY_MASK             0xED    /* bit 4,1 = don't care */

#define ataTASK_LOST                    0xFC
#define ataTASK_NOT_COMPLETED           0xFD
#define ataTASK_NOT_SUBMITTED           0xFE    /* raid engine use */

/*
 * DTASK.ata_reg.cmd.bFeature ATA Status Register Values
 */
#define ataBAD_BLOCK                    bit(7)  /* BBK */
#define ataUNCORRECTABLE_DATA_ERROR     bit(6)  /* UNC */
#define ataSECTOR_ID_NOT_FOUND          bit(4)  /* IDNF */
#define ataCOMMAND_ABORTED              bit(2)  /* ABRT */
#define ataTRACK_0_NOT_FOUND            bit(1)  /* TKNOF */
#define ataADDRESS_MARK_NOT_FOUND       bit(0)  /* AMNF */

